﻿__copyright__ = "Copyright (c) 2016 CollabNet, Inc. All rights reserved."

from app.scripts import BaseCreateRuntimeScript
import app.util
import app.batch
import app.preprocessor
import os
import shutil

class CreateRuntimeScript(BaseCreateRuntimeScript):

    scriptDescription = "Generate rabbitmq-env.conf"
    
    def createFolderIfNotExisting(self, folder):
        if not os.path.exists(folder):
            try:
                os.makedirs(folder)
            except:
                self.logMesg("warn", "Creating folder %s failed" %folder)

    def createRuntime(self):
        self.createFolderIfNotExisting("/etc/rabbitmq")
        app.batch.ConfigBatch(self.log) \
            .addFolder(os.path.join(app.defaults.DEFAULT_SERVICE_DIR, 'rabbitmq', 'conf-snippets', 'rabbitmq-env.conf.d')) \
            .evaluateIntoFile("/etc/rabbitmq/rabbitmq-env.conf")

