__copyright__ = "Copyright (c) 2017 CollabNet, Inc. All rights reserved."

from app.scripts import BaseFolderScript
import os
import platform
from app.selinuxutil import Policy


class FolderScript(BaseFolderScript):

    def createFolders(self):
        pass

    def deleteFolders(self):
        pass

    def areSELinuxPermissionsApplied(self):

        rabbitmqDataDir = self.cfg['RABBITMQ_DATA_DIR']
        rabbitmqLogDir = self.cfg['RABBITMQ_LOG_DIR']
        rabbitmqConfigDir = self.cfg['RABBITMQ_CONFIG']
        rabbitmqBinDir = self.cfg['RABBITMQ_BIN']
        rabbitmqPluginsFile = self.cfg['RABBITMQ_PLUGINS']
        rabbitmqSBinDir = os.path.dirname(os.path.realpath(os.path.join(rabbitmqBinDir, 'rabbitmqctl')))
        platform_list = platform.dist()
        if platform_list[0] == "redhat" or platform_list[0] == "centos":
            version_list = platform_list[1].split(".")
            if version_list[0] > '6':
                if not Policy.isSELinuxPermissionsApplied(rabbitmqDataDir, 'rabbitmq_var_lib_t') or \
                   not Policy.isSELinuxPermissionsApplied(rabbitmqLogDir, 'rabbitmq_var_log_t') or \
                   not Policy.isSELinuxPermissionsApplied(rabbitmqConfigDir, 'rabbitmq_unit_file_t') or \
                   not Policy.isSELinuxPermissionsApplied(rabbitmqBinDir, 'rabbitmq_initrc_exec_t') or \
                   not Policy.isSELinuxPermissionsApplied(rabbitmqSBinDir, 'rabbitmq_initrc_exec_t') or \
                   not Policy.isSELinuxPermissionsApplied(rabbitmqPluginsFile, 'rabbitmq_var_lib_t'):
                       return False

    def applySELinuxPermissions(self):

        rabbitmqDataDir = self.cfg['RABBITMQ_DATA_DIR']
        rabbitmqLogDir = self.cfg['RABBITMQ_LOG_DIR']
        rabbitmqConfigDir = self.cfg['RABBITMQ_CONFIG']
        rabbitmqBinDir = self.cfg['RABBITMQ_BIN']
        rabbitmqPluginsFile = self.cfg['RABBITMQ_PLUGINS']
        rabbitmqSBinDir = os.path.dirname(os.path.realpath(os.path.join(rabbitmqBinDir, 'rabbitmqctl')))

        platform_list = platform.dist()
        if platform_list[0] == "redhat" or platform_list[0] == "centos":
            version_list = platform_list[1].split(".")
            if version_list[0] > '6':
                Policy.applySELinuxPermissions(rabbitmqDataDir, 'rabbitmq_var_lib_t')
                Policy.applySELinuxPermissions(rabbitmqLogDir, 'rabbitmq_var_log_t')
                Policy.applySELinuxPermissions(rabbitmqConfigDir, 'rabbitmq_unit_file_t')
                Policy.applySELinuxPermissions(rabbitmqBinDir, 'rabbitmq_initrc_exec_t')
                Policy.applySELinuxPermissions(rabbitmqSBinDir, 'rabbitmq_initrc_exec_t')
                Policy.applySELinuxPermissions(rabbitmqPluginsFile, 'rabbitmq_var_lib_t')

