import os
import app.servicecontrol

class ServiceController(app.servicecontrol.ServiceController):
    def getPidFile(self):
        return os.path.join("/var/run/rabbitmq/pid")

    def __runInit(self, verb):
        config = app.util.getRuntimeConfiguration()

        logFile = os.path.join(config['RABBITMQ_LOG_DIR'], 'service.log')

        # NOTE: the init.d script (or its systemd intercept) calls the script
        # which runs the server under the rabbitmq user.
        initScript = '/etc/init.d/rabbitmq-server'

        return os.system("%s %s < /dev/null >> %s 2>&1 &" % (initScript, verb, logFile)) == 0

    def startDaemonAsync(self):
        return self.__runInit("start")

    def stopDaemonAsync(self):
        return self.__runInit("stop")

    def isBootstrapped(self):
        config = app.util.getRuntimeConfiguration()
        return os.path.isdir(config['RABBITMQ_DATA_DIR'])